/*
 * (C) Copyright IBM Corp. 2004
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   Konrad Rzeszutek <konradr@us.ibm.com>

 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18 2003/11/07 17:03:52 rstory Exp $
 *
 * $Id: saHpiSensorThdNegHysteresisTable.h,v 1.2 2004/03/23 04:20:20 konradrzeszutek Exp $
 *
 */
#ifndef SAHPISENSORTHDNEGHYSTERESISICALTABLE_H
#define SAHPISENSORTHDNEGHYSTERESISICALTABLE_H

#ifdef __cplusplus
extern "C"
{
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>
#include <SaHpi.h>
#include <hpiSubagent.h>


	/** Index saHpiDomainID is external */
	/** Index saHpiResourceID is external */
	/** Index saHpiSensorIndex is external */

  typedef struct saHpiSensorThdNegHysteresisTable_context_s
  {
    netsnmp_index index;

    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdNegHysteresisIsReadable;
    
    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdNegHysteresisIsWritable;
    
    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdNegHysteresisIsFixed;
    
    /** INTEGER = ASN_INTEGER */
    long            saHpiSensorThdNegHysteresisValuesPresent;

    /** UNSIGNED32 = ASN_UNSIGNED */
    unsigned long   saHpiSensorThdNegHysteresisRaw;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorThdNegHysteresisInterpreted[SENSOR_THD_INTER_MAX];
    size_t saHpiSensorThdNegHysteresisInterpreted_len;


    SaHpiResourceIdT resource_id;
    SaHpiDomainIdT domain_id;
    SaHpiSensorNumT sensor_id;

    long hash;


  } saHpiSensorThdNegHysteresisTable_context;

/*************************************************************
 * function declarations
 */

  void initialize_table_saHpiSensorThdNegHysteresisTable (void);

  int
    delete_ThdNegHysteresis_row (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT num);

  int populate_ThdNegHysteresis (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT sensor_id,
			       SaHpiSensorThdDefnT *threshold_def,
			       SaHpiSensorReadingT * reading);


  int set_ThdNegHysteresis (saHpiSensorThdNegHysteresisTable_context *ctx);

  int
    saHpiSensorThdNegHysteresisTable_get_value (netsnmp_request_info *,
					      netsnmp_index *,
					      netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
  extern oid saHpiSensorThdNegHysteresisTable_oid[];
  extern size_t saHpiSensorThdNegHysteresisTable_oid_len;

#define saHpiSensorThdNegHysteresisTable_TABLE_OID hpiSensor_OID,14

/*************************************************************
 * column number definitions for table saHpiSensorThdNegHysteresisTable
 */
#define COLUMN_SAHPISENSORTHDNEGHYSTERESISICALISREADABLE 1
#define COLUMN_SAHPISENSORTHDNEGHYSTERESISICALISWRITABLE 2
#define COLUMN_SAHPISENSORTHDNEGHYSTERESISICALISFIXED 3
#define COLUMN_SAHPISENSORTHDNEGHYSTERESISICALVALUESPRESENT 4
#define COLUMN_SAHPISENSORTHDNEGHYSTERESISICALRAW 5
#define COLUMN_SAHPISENSORTHDNEGHYSTERESISICALINTERPRETED 6
#define saHpiSensorThdNegHysteresisTable_COL_MIN 1
#define saHpiSensorThdNegHysteresisTable_COL_MAX 6

  int
    saHpiSensorThdNegHysteresisTable_extract_index
    (saHpiSensorThdNegHysteresisTable_context * ctx, netsnmp_index * hdr);

  void saHpiSensorThdNegHysteresisTable_set_reserve1 (netsnmp_request_group *);
  void saHpiSensorThdNegHysteresisTable_set_reserve2 (netsnmp_request_group *);
  void saHpiSensorThdNegHysteresisTable_set_action (netsnmp_request_group *);
  void saHpiSensorThdNegHysteresisTable_set_commit (netsnmp_request_group *);
  void saHpiSensorThdNegHysteresisTable_set_free (netsnmp_request_group *);
  void saHpiSensorThdNegHysteresisTable_set_undo (netsnmp_request_group *);

    saHpiSensorThdNegHysteresisTable_context
    * saHpiSensorThdNegHysteresisTable_duplicate_row
    (saHpiSensorThdNegHysteresisTable_context *);
    netsnmp_index
    * saHpiSensorThdNegHysteresisTable_delete_row
    (saHpiSensorThdNegHysteresisTable_context *);

  int
    saHpiSensorThdNegHysteresisTable_can_delete
    (saHpiSensorThdNegHysteresisTable_context * undo_ctx,
     saHpiSensorThdNegHysteresisTable_context * row_ctx,
     netsnmp_request_group * rg);



    saHpiSensorThdNegHysteresisTable_context
    * saHpiSensorThdNegHysteresisTable_create_row (netsnmp_index *);

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORTHDNEGHYSTERESISICALTABLE_H */
